/*********************************************************************/ 
/*                                                                   */ 
/*             Config files library - (C) TGG 2015                   */ 
/*                                                                   */ 
/*********************************************************************/ 
/*                          Warszawa, 2015                           */ 
/*********************************************************************/ 
/*                                                                   */
/* File: conect_data.h                                               */
/*                                                                   */
/* Author: T.Grabowski                                               */
/*                                                                   */
/* Contents - CONNECT_DATA class                                     */
/*                                                                   */ 
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/*                                                                   */

#include "conect_data.h"

using namespace std;

CONNECT_DATA::CONNECT_DATA( void )
{
	TypeStr[0] = (char*)"Horizontal";
	TypeStr[1] = (char*)"Vertical";
	TypeStr[2] = (char*)"Parallel";
}

CONNECT_DATA::~CONNECT_DATA( void )
{
}

int CONNECT_DATA::Read( FILE *t, int typ, int version )
{
	if( version == 2 )
		{
		iTyp = typ;
		iActive = 1;
		}
	else
		{
		char sTyp[256];
		ReadStr( t, sTyp );
		
		if( CompareStrings( sTyp, TypeStr[CON_H]) == true )
			iTyp = CON_H;
		else if( CompareStrings( sTyp, TypeStr[CON_V]) == true )
			iTyp = CON_V;
		else if( CompareStrings( sTyp, TypeStr[CON_P]) == true )
			iTyp = CON_P;
		else
			{
			iTyp = -1;
			return -1;
			}
		//fprintf(stdout,"Conn : type %s\n", sTyp);
		}
		
	char name[255];
	ReadStr ( t, name );   // description
	ConName = string( name );
	if( version != 2 )fscanf ( t, "%d", &iActive );
	fscanf ( t, "%d", &CP1 );
	fscanf ( t, "%d", &CP2 );
	fscanf ( t, "%d", &Czeb1 );
	fscanf ( t, "%d", &Czeb2 );
	fscanf ( t, "%d", &Cstart );
	fscanf ( t, "%d", &Cend );
	ReadPar ( t, "%d", &Csurf );

	return 0;
}

int CONNECT_DATA::Write( ostream &fout )
{
	fout << TypeStr[iTyp] << endl;
	fout << ConName << endl;
	fout << iActive << " ";
	fout << CP1 << " ";
	fout << CP2 << " ";
	fout << Czeb1 << " ";
	fout << Czeb2 << " ";
	fout << Cstart << " ";
	fout << Cend << " ";
	fout << Csurf << endl;
	return 0;
}

