/*********************************************************************/ 
/*                                                                   */ 
/*             Config files library - (C) TGG 2018                   */ 
/*                                                                   */ 
/*********************************************************************/ 
/*                          Warszawa, 2018                           */ 
/*********************************************************************/ 
/*                                                                   */
/* File: czy_file.h                                                  */
/*                                                                   */
/* Author: T.Grabowski                                               */
/*                                                                   */
/* Contents - spanwise distribution output file class declaration    */
/*                                                                   */ 
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/*                                                                   */

#ifndef _CZY_FILE_H_
#define _CZY_FILE_H_

#include "txt_out_file.h"

/// Spanwise distribution output file of Press program: aerodynamic coefficients, reference values, etc.
	/**
	*  The list of variables:\n
	*  -#	 x - coordinate\n
	*  -#	 y - coordinate\n
	*  -#	 z - coordinate\n
	*  -#	 r - spanwise coordinate\n
	*  -#    Cx - coefficient (drag)\n
	*  -#    Cy - coefficient (side force)\n
	*  -#    Cz - coefficient (lift)\n
	*  -#    Cmx - coefficient (rolling moment)\n
	*  -#    Cmy - coefficient (pitching moment)\n
	*  -#	 Cmz - coefficient (yaw moment)\n
	*  -#	 Si - slice area\n
	*  -#	 Ci - slice chord\n
	*  -#	 Si_xy - projection to xy plane of slice area\n
	*  -#	 Cn - normal (to slice plane) force coefficient\n
	*  -#	 Cms - twisting moment coefficient \n
	*  -#	 dy - y coordinate increment\n
	*  -#	 dz - z coordinate increment \n
	*  -#	 dr - spanwise increment \n
	*  -#	 Czi - lift coefficient related to induced drag (optional)\n
	*  -#	 Cxi - induced drag coefficient (optional)
	*/


class CZY_FILE : public TXT_OUT_FILE
{
	public:
	
	CZY_FILE( void );
	~CZY_FILE( void );

/// cleans local variables
	void Clean( void );
};

#endif /*_CZY_FILE_H_*/
