/**********************************************************************/
/*                                                                    */
/*              Config files library  - (C) TGG 2015                  */
/*                                                                    */
/**********************************************************************/
/*                          Warsaw 2008                               */
/**********************************************************************/
/*                                                                    */
/* File: memfun.cpp                                                   */
/*                                                                    */
/* Written by: F.A.Dul, T.Grabowski                                   */
/*                                                                    */
/* Contents: overloaded "new" operator initializing object with zeros */
/*                                                                    */
/**********************************************************************/
/*                                                                    */
/*                                                                    */

#include "memfun.h"

using namespace std;

void* MEMFUN::operator new ( size_t st , const char *text, int ierr_print )
{
	void *pv = ::operator new( st );
	if( pv )
		{
		memset( pv , 0 , st );
		if( ierr_print )
		        cerr << "MEMFUN: object " << text
		             << " allocated, address: " << pv 
		             << "  size=" << st << endl;
		}
	else
		{
		cout << " MEMFUN: object " << text
		     << "  is not allocated !!!" << endl;
		exit( -1 );
		}

	return pv;
}
