/*********************************************************************/
/*                                                                   */
/*             Config files library - (C) TGG 2018                   */
/*                                                                   */
/*********************************************************************/
/*                          Warszawa, 2018                           */
/*********************************************************************/
/*                                                                   */
/* File: panukl_auto.h                                               */
/*                                                                   */
/* Author: T.Grabowski                                               */
/*                                                                   */
/* Contents - auto file data (sequence computation) class            */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/*                                                                   */

#include "panukl_auto.h"

PANUKL_AUTO::PANUKL_AUTO( void ){ Clean (); }

PANUKL_AUTO::~PANUKL_AUTO( void ){}

void PANUKL_AUTO::Clean( void )
{
	Ms2Flag = 0;
	NghFlag = 0;
	ParFlag = 0;
	PrsFlag = 0;
	
	memset( Ms2File, 0, 256 );
	memset( NghFile, 0, 256 );
	memset( ParFile, 0, 256 );
	memset( PrsFile, 0, 256 );

	memset( AUTO_file, 0, 256 );
}

int PANUKL_AUTO::Read( const char *AutoFile )
{
	FILE *File;
	File = fopen( AutoFile, "r" );
	if( File == NULL )
		{
		fprintf( stderr, "[.auto] file open error to reading (%s)\n", AutoFile );
		return (-1);
		}

	ReadPar( File, "%d", &Ms2Flag );
	ReadPar( File, "%d", &NghFlag );
	ReadPar( File, "%d", &ParFlag );
	ReadPar( File, "%d", &PrsFlag );
	ReadStr( File, Ms2File );
	ReadStr( File, NghFile );
	ReadStr( File, ParFile );
	ReadStr( File, PrsFile );

	fclose( File );

	ClipFileName( Ms2File );
	ClipFileName( NghFile );
	ClipFileName( ParFile );
	ClipFileName( PrsFile );
	
	strcpy( AUTO_file, AutoFile );
	
	return (0);
}

int PANUKL_AUTO::Write( const char *AutoFile )
{
	FILE *File;
	File = fopen( AutoFile, "w" );
	if( File == NULL )
		{
		fprintf( stderr, "[.auto] file open error to writing (%s)\n", AutoFile );
		return (-1);
		}

	fprintf( File, "%d\n", Ms2Flag );
	fprintf( File, "%d\n", NghFlag );
	fprintf( File, "%d\n", ParFlag );
	fprintf( File, "%d\n", PrsFlag );
	fprintf( File, "%s\n", Ms2File );
	fprintf( File, "%s\n", NghFile );
	fprintf( File, "%s\n", ParFile );
	fprintf( File, "%s\n", PrsFile );

	fclose( File );
	
	strcpy( AUTO_file, AutoFile );
	
	return (0);
}

