/*********************************************************************/
/*                                                                   */
/*             Config files library - (C) TGG 2018                   */
/*                                                                   */
/*********************************************************************/
/*                          Warszawa, 2018                           */
/*********************************************************************/
/*                                                                   */
/* File: panukl_auto.h                                               */
/*                                                                   */
/* Author: T.Grabowski                                               */
/*                                                                   */
/* Contents - auto file data (sequence computation) class            */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/*                                                                   */

#ifndef _PANUKL_AUTO_H_
#define _PANUKL_AUTO_H_

#include "iofun.h"

/// Parameters file for PanuklAuto program (computation of one sequence)

class PANUKL_AUTO : public IOFUN
{
	public:
	
	bool Ms2Flag;                    ///< Mesh program flag (1-run Mesh3 with Ms2File, 0-don't run Mesh)
	bool NghFlag;                    ///< Neigh program flag (1-run Neigh with NghFile, 0-don't run Neigh)
	bool ParFlag;                    ///< Panukl program flag (1-run Panukl with ParFile, 0-don't run Panukl)
	bool PrsFlag;                    ///< Press program flag (1-run Press with PrsFile, 0-don't run Press)
	
	char Ms2File[256];               ///< MS2 filename
	char NghFile[256];               ///< NGH filename
	char ParFile[256];               ///< PAR filename
	char PrsFile[256];               ///< PRS filename
	
	char AUTO_file[256];             ///< AUTO filename

	PANUKL_AUTO( void );
	~PANUKL_AUTO( void );	
/// cleans local variables	
	void Clean();
/// reads AUTO file
	int Read(const char *AutoFile);
/// writes AUTO file
	int Write(const char *AutoFile);
};

#endif /*_PANUKL_AUTO_H_*/
