/*********************************************************************/ 
/*                                                                   */ 
/*             Config files library - (C) TGG 2019                   */ 
/*                                                                   */ 
/*********************************************************************/ 
/*                          Warszawa, 2019                           */ 
/*********************************************************************/ 
/*                                                                   */
/* File: polar_file.h                                                */
/*                                                                   */
/* Author: T.Grabowski                                               */
/*                                                                   */
/* Contents - longitudinal aerodynamic characteritics wrt AoA        */
/*                                                                   */ 
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/*                                                                   */

#ifndef _POLAR_FILE_H_
#define _POLAR_FILE_H_

#include "txt_out_file.h"

/// Polar file - longitudinal aerodynamic characteritics wrt Alfa (angle of attack)
	/**
	*  The list of variables:\n
	*  -#	 Alfa - angle of attack [deg]\n
	*  -#    Cx - coefficient (body axis system)
	*  -#    Cz - coefficient (body axis system)
	*  -#    Cm - coefficient (body axis system)
	*  -#    Cxs - coefficient (stability/velocity axis system)
	*  -#    Czs - coefficient (stability/velocity axis system) - total lift 
	*  -#	 Cxi - induced drag coefficient
	*  -#	 Czi - lift coefficient corresponding with Cxi
	*  -#	 CD - total drag coeficient
	*/

class POLAR_FILE : public TXT_OUT_FILE
{
	public:
	
	POLAR_FILE( void );
	~POLAR_FILE( void );

/// cleans local variables
	void Clean( void );
};

#endif /*_POLAR_FILE_H_*/
